//------------------------------------------------------------------
//
//------------------------------------------------------------------
#property copyright "www.forex-tsd.com"
#property link      "www.forex-tsd.com"

#property indicator_chart_window
#property indicator_buffers 3
#property indicator_color1  PaleVioletRed
#property indicator_color2  DeepSkyBlue
#property indicator_color3  DimGray
#property indicator_style1  STYLE_DOT
#property indicator_style2  STYLE_DOT
#property indicator_style3  STYLE_DOT

//
//
//
//
//

extern int    Length             = 14;
extern int    Price              = PRICE_CLOSE;
extern bool   SampleDeviation    = true;
extern double BandUpMultiplier   = 1.5;
extern double BandDownMultiplier = 1.5;

double sma[];
double bandUp[];
double bandDn[];


//------------------------------------------------------------------
//                                                                  
//------------------------------------------------------------------
// 
//
//
//
//

int init()
{
   SetIndexBuffer(0,bandUp);
   SetIndexBuffer(1,bandDn);
   SetIndexBuffer(2,sma);

      string add = ""; 
         if (SampleDeviation) add = "of sample deviation ";
         IndicatorShortName("Bolinger bands "+add+"("+Length+")");
   return(0);
}

//
//
//
//
//

int start()
{
   int counted_bars=IndicatorCounted();
      if(counted_bars<0) return(-1);
      if(counted_bars>0) counted_bars--;

   //
   //
   //
   //
   //
   
   for(int i=MathMin(Bars-counted_bars,Bars-1); i>=0; i--)
   {
      double dev = iDeviation(iMA(NULL,0,1,0,MODE_SMA,Price,i),Length,SampleDeviation,i);
             sma[i] = iMA(NULL,0,Length,0,MODE_SMA,Price,i);
             bandUp[i] = sma[i]+dev*BandUpMultiplier;
             bandDn[i] = sma[i]-dev*BandDownMultiplier;
   }      
   return(0);
}

//------------------------------------------------------------------
//                                                                  
//------------------------------------------------------------------
// 
//
//
//
//

double workDev[];
double iDeviation(double value, int length, bool isSample, int i)
{
   if (ArraySize(workDev)!=Bars) ArrayResize(workDev,Bars); i=Bars-i-1; workDev[i] = value;
                 
   //
   //
   //
   //
   //
   
   double oldMean   = value;
   double newMean   = value;
   double squares   = 0;
   for (int k=1; k<length && (i-k)>=0; k++)
   {
      newMean  = (workDev[i-k]-oldMean)/(k+1)+oldMean;
      squares += (workDev[i-k]-oldMean)*(workDev[i-k]-newMean);
      oldMean  = newMean;
   }
   return(MathSqrt(squares/MathMax(k-isSample,1)));
}